# This is the Gradle build system for JVM applications
# https://gradle.org/
# https://github.com/gradle/gradle
#image: gradle:alpine
image: java:latest
#
# Disable the Gradle daemon for Continuous Integration servers as correctness
# is usually a priority over speed in CI environments. Using a fresh
# runtime for each build is more reliable since the runtime is completely
# isolated from any previous builds.
variables:
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"
  DOCKER_USER: root
  #For the workaround these three vars:
  DOCKER_TLS_CERTDIR: ""
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
services:
    - name: docker:dind
      entrypoint: ["env", "-u", "DOCKER_HOST"]
      command: ["dockerd-entrypoint.sh"]

workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: $CI_COMMIT_TAG
      when: always
    - if: $CI_MERGE_REQUEST_IID
      when: always

stages:
  - test
  - build
  - deploy

###############################################################################
# When it runs:
# for every pipeline
# What it does:
# Tests the server. This step is not necessarily
# Todos
# - The configurations things in script are duplicates in build_stage_server.
# - Eliminate this duplicates.
###############################################################################
test_stage_server:
  stage: test
  image: gradle:7.2.0-jdk17-alpine
  script:
        - pwd
        - apk update
        - apk upgrade
        - apk add bash
        - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/stephan.mathys/divelogbook.private.git ../divelogbook.private
        - ln -s /builds/stephan.mathys/divelogbook.private/application-stage.yml /builds/stephan.mathys/divelogbook/server/src/main/resources
        - mkdir /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - ln -s /builds/stephan.mathys/divelogbook.private/application-aws.yml /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - ln -s /builds/stephan.mathys/divelogbook.private/application-db.yml /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - cd server
        - ./gradlew test -Pprofile=test

###############################################################################
# When it runs:
# for every pipeline
# What it does:
# Builds the client
###############################################################################
build_stage_client:
  stage: build
  image: node:lts-alpine
  script:
        - cd dive-client
        - yarn install
        - yarn build
  artifacts:
    paths: 
        - dive-client/dist/
    expire_in: 1 week

###############################################################################
# When it runs:
# for every pipeline
# What it does:
# build the server
###############################################################################
build_stage_server:
  stage: build
  image: gradle:7.2.0-jdk17-alpine
  script:
        - pwd
        - apk update
        - apk upgrade
        - apk add bash
        - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/stephan.mathys/divelogbook.private.git ../divelogbook.private
        - ln -s /builds/stephan.mathys/divelogbook.private/application-stage.yml /builds/stephan.mathys/divelogbook/server/src/main/resources
        - mkdir /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - ln -s /builds/stephan.mathys/divelogbook.private/application-aws.yml /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - ln -s /builds/stephan.mathys/divelogbook.private/application-db.yml /builds/stephan.mathys/divelogbook/server/src/main/resources/configurations
        - cd server
        - ./gradlew bootJar -Pprofile=test
  artifacts:
    paths: 
      - server/build/libs/*.jar
    expire_in: 1 week

###############################################################################
# When it runs:
# only runs when a tag is pushed like stage_v0.0.0
# What it does:
# delete the client-stage env on aws and redeploy the client on aws
###############################################################################
deploy_stage_client:
  stage: deploy
  dependencies:
    - build_stage_client
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest 
  rules:
    - if: $CI_COMMIT_TAG =~ /^stage_v\d+(?:.\d+)+$/
      when: always
    - when: never
  script:
    - aws s3 rm s3://divelogbook.sause.ch/ --recursive
    - aws s3 cp dive-client/dist s3://divelogbook.sause.ch/ --recursive

###############################################################################
# When it runs:
# only runs when a tag is pushed like prod_v0.0.0
# What it does:
# Deploys the server on the live environment
# Todos:
#  - should be the same task as deploy_stage_client
###############################################################################
deploy_stage_server:
  stage: deploy
  image: alpine:latest
  before_script:
    - apk update && apk add openssh-client bash
    - mkdir -p ~/.ssh
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - touch ~/.ssh/config
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - ssh-keyscan -H $DEPLOY_SERVER_IP >> ~/.ssh/known_hosts
    - echo "Finish bevore script"
  script:
    - echo "Deploying started..."
# Deployment deacitvated at the moment    
#    - scp server/build/libs/*.jar ec2-user@$DEPLOY_SERVER_IP:~/divelogserver/
    - echo "Finished deploying the app."
  rules:
    - if: $CI_COMMIT_TAG =~ /^stage_v\d+(?:.\d+)+$/
      when: always
    - when: never 